'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo which sends keystrokes to a window running in a
' separate thread. In this case, sending keystrokes
' to the xblite html help file. You must start the xblite
' html help file before running this demo.
'
PROGRAM "sendkey"
VERSION "0.0001"
CONSOLE
'
	IMPORT  "xst"
	IMPORT  "xsx"
'	IMPORT  "xio"
	IMPORT	"gdi32"
	IMPORT  "user32"
	IMPORT  "kernel32"

TYPE HARDWAREINPUT
  XLONG   .uMsg
  USHORT  .wParamL
  USHORT  .wParamH
END TYPE

TYPE KEYBDINPUT
  USHORT .wVk						' virtual-key code, range 1 to 254
  USHORT .wScan					' hardware scan code for the key
  XLONG  .dwFlags
  XLONG  .time					' time stamp for the event, in msec
  ULONG  .dwExtraInfo
END TYPE

TYPE MOUSEINPUT
  XLONG     .dx
  XLONG     .dy
  XLONG     .mouseData
  XLONG     .dwFlags
  XLONG     .time
  ULONG     .dwExtraInfo
END TYPE

TYPE INPUT
  XLONG .type
  UNION
    MOUSEINPUT    .mi
    KEYBDINPUT    .ki
    HARDWAREINPUT .hi
  END UNION
END TYPE

' flags for MOUSEINPUT
'$$KEYEVENTF_EXTENDEDKEY = 0x0001
'$$KEYEVENTF_KEYUP = 0x0002
$$KEYEVENTF_SCANCODE = 0x0008
$$KEYEVENTF_UNICODE = 0x0004

' input type
$$INPUT_MOUSE = 0
$$INPUT_KEYBOARD = 1
$$INPUT_HARDWARE = 2



'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION InputKeyboard (vk, flags)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	' manually start the help file for xblite
	' get handle to help window
	hWnd = FindWindowA (NULL, &"XBLite for Windows User's Manual")
	PRINT "hWnd = "; hWnd

	SetForegroundWindow (hWnd)

	' send keystrokes to help window
	' ALT + N to get Index
	keybd_event ($$VK_MENU, MapVirtualKeyA ($$VK_MENU, 0), 0, 0)			' key down
	keybd_event ('N', MapVirtualKeyA ('N', 0), 0, 0)
	keybd_event ('N', MapVirtualKeyA ('N', 0), $$KEYEVENTF_KEYUP, 0)	' key up
	keybd_event ($$VK_MENU, MapVirtualKeyA ($$VK_MENU, 0), $$KEYEVENTF_KEYUP, 0)

	' ASM
	keybd_event ('A', MapVirtualKeyA ('A', 0), 0, 0)
	keybd_event ('A', MapVirtualKeyA ('A', 0), $$KEYEVENTF_KEYUP, 0)
	keybd_event ('S', MapVirtualKeyA ('S', 0), 0, 0)
	keybd_event ('S', MapVirtualKeyA ('S', 0), $$KEYEVENTF_KEYUP, 0)
	keybd_event ('M', MapVirtualKeyA ('M', 0), 0, 0)
	keybd_event ('M', MapVirtualKeyA ('M', 0), $$KEYEVENTF_KEYUP, 0)

	' Enter
	keybd_event ($$VK_RETURN, MapVirtualKeyA ($$VK_RETURN, 0), 0, 0)
	keybd_event ($$VK_RETURN, MapVirtualKeyA ($$VK_RETURN, 0), $$KEYEVENTF_KEYUP, 0)

	Sleep (4000)

' Or for XP, Vista, Win7, try using SendInput function

	' Alt-N
	InputKeyboard ($$VK_MENU, 0)
	InputKeyboard ('N', 0)
	InputKeyboard ('N', $$KEYEVENTF_KEYUP)
	InputKeyboard ($$VK_MENU, $$KEYEVENTF_KEYUP)

	' 3 Backspaces
	InputKeyboard ($$VK_BACK, 0)
	InputKeyboard ($$VK_BACK, $$KEYEVENTF_KEYUP)
	InputKeyboard ($$VK_BACK, 0)
	InputKeyboard ($$VK_BACK, $$KEYEVENTF_KEYUP)
	InputKeyboard ($$VK_BACK, 0)
	InputKeyboard ($$VK_BACK, $$KEYEVENTF_KEYUP)

	' M4
	InputKeyboard ('M', 0)
	InputKeyboard ('M', $$KEYEVENTF_KEYUP)
	InputKeyboard ('4', 0)
	InputKeyboard ('4', $$KEYEVENTF_KEYUP)

	' Enter
	InputKeyboard ($$VK_RETURN, 0)
	InputKeyboard ($$VK_RETURN, $$KEYEVENTF_KEYUP)

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
'
' ###########################
' #####  InputKeyboard  #####
' ###########################
'
'
'
FUNCTION InputKeyboard (vk, flags)

	INPUT input[]

	DIM input[0]
	DIM args[2]		' three arguments, nInputs, pInputs, cbSize

	input[0].type           = $$INPUT_KEYBOARD
	input[0].ki.wVk         = vk
	input[0].ki.wScan       = 0 'MapVirtualKeyA (vk, 0)
	input[0].ki.dwFlags     = flags
	input[0].ki.time        = 0
	input[0].ki.dwExtraInfo = 0

	args[0] = 1
	args[1] = &input[]
	args[2] = SIZE(input[])

	RETURN XstCall ("SendInput", "user32.dll", @args[])

END FUNCTION
END PROGRAM