'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo which uses an UnComment()
' function to remove any comments
' from a line of code.
'
VERSION	"0.0005"
CONSOLE
'
IMPORT	"xst"
'IMPORT	"xsx"
'IMPORT	"xio"
'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION UnComment (@source$, @code$, @comment$)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

' add some rows to console buffer
'	hStdOut = XioGetStdOut ()
'	XioSetConsoleBufferSize (hStdOut, 100, 250)

	DIM text$[11]
	upper = UBOUND (text$[])

	text$[0] = "A normal line of text without any comments"
	text$[1] = "'This is some text in a commented line"
	text$[2] = "IF LIBRARY(0) THEN RETURN    ' main program has message loop"
	text$[3] = "$$ResetAssembly	= 1          ' For ResetDataDisplays()"
	text$[4] = "IF entry THEN RETURN         ' enter once"
	text$[5] = "CASE 'a' : PRINT \"Do Something 'NOW'\"  ' this is the comment part"
	text$[6] = "IF LEFT$(source$, 1) = \"'\" || LEFT$(source$, 1) = \"?\" THEN x = 0"
	text$[7] = "CASE '\"', ''', '!', '%', '\\\\', '\\t', '\\a' : DO NEXT  ' this is the comment"
	text$[8] = "\t\tsome code here\t\t\t\t' here is comment"
	text$[9] = "ASM mov eax,1    ; comment"
	text$[10] = "' ' some text"
	text$[11] = "FOR i=0 TO 100:x=i:NEXT i' this line needs some whitespace"

	FOR i = 0 TO upper
		PRINT
		PRINT " ***** Original *****"
		PRINT text$[i]
		PRINT

		PRINT " ***** Uncommented *****"
		err = UnComment (text$[i], @code$, @comment$)
		PRINT "code   : "; code$
		PRINT "comment: "; comment$
	NEXT i

	PRINT
	a$ = INLINE$("Press ENTER to exit >")

	RETURN

END FUNCTION
'
'
' ##########################
' #####  UnComment ()  #####
' ##########################
'
' PURPOSE	: Remove commented part of line
' IN      : source$  - line of code to remove comment
' OUT     : comment$ - extracted comment string
'					: code$    - decommented line of code
'
FUNCTION UnComment (@source$, @code$, @comment$)

	IFZ source$ THEN RETURN $$TRUE
	
	comment$ = ""
	code$ = ""

  rawline$ = TRIM$(source$)
	rawLength = LEN(rawline$)
	
	DO 	
		charV = rawline${charPtr}
		INC charPtr
		IF charV = '"' THEN GOSUB Double_Quote
		IF charV = ''' THEN GOSUB Remark
		INC count
	LOOP UNTIL charV = 0
	
	' no comment found
	code$ = source$
	RETURN

' *****  '  *****  Remark  *****	
	
SUB Remark
	IFZ count THEN GOTO sendRemark								' first char ' is a remark
	charV = rawline${charPtr}											' 1st byte of comment / charcon
	IFZ charV THEN																' nothing after ' character, so
		comment$ = "'"															' ...it's an empty comment
		code$ = LEFT$(rawline$, LEN(rawline$)-1) 		' grab code$
		RETURN 																			' that's all folks
	ELSE																					' comment or charcon follows
		IF charV THEN charW = rawline${charPtr+1}		' 2nd byte of comment or charcon
		IF charW THEN charX = rawline${charPtr+2}		' 3rd byte of comment or charcon
		IF charX THEN charY = rawline${charPtr+3}		' 4th byte of comment or charcon
		SELECT CASE TRUE
			CASE ((charW = ''') AND (charV != '\\')):	 c = 3	'  '?'   charcon
			CASE ((charV = '\\') AND (charX = ''')) :	 c = 4	'  '\?'  charcon
			CASE ELSE:	GOTO sendRemark												'  comment, not charcon
		END SELECT
	ENDIF

' It's a charcon  ( '?'  ...or...  '\?' )

	charPtr = charPtr + c - 1										' skip over it and exit
	EXIT SUB

sendRemark:
	length = (rawLength - charPtr) + 1					' length of comment in bytes
	code$ = LEFT$(rawline$, charPtr-1)					' grab code$
	comment$ = RIGHT$(rawline$, length)					' grab comment$
	RETURN																			' exit 
	
END SUB	

' *****  "  *****  Literal string  *****

SUB Double_Quote
	scans = charPtr				' 0 offset to character after opening double-quote
	start = charPtr				' 1 offset to opening double-quote
 	final = rawLength			' 0 offset to null-terminator
	IF (scans < final) THEN
		rawChar = rawline${scans}
		DO UNTIL (rawChar = '"')
			IF (rawChar = '\\') THEN
				INC scans
				rawChar = rawline${scans}
			ENDIF
			INC scans
			rawChar = rawline${scans}
		LOOP WHILE (scans < final)
	ENDIF
	
	IF (scans < final) THEN
		INC scans
		charPtr = scans		' terminated by "  (normal case)
	ELSE
		charPtr	= scans		' terminated by null, not "
	ENDIF
	
END SUB	

END FUNCTION

END PROGRAM
