

' demo to create a dialog box with controls from a dialog template in memory
'
PROGRAM "dlgtemplate"
VERSION "0.0001"

IMPORT "xst"				' Standard library : required by most programs
IMPORT "xsx"				' Extended standard library
IMPORT "gdi32"			' gdi32.dll
IMPORT "user32"			' user32.dll
IMPORT "kernel32"		' kernel32.dll
IMPORT "comctl32"		' comctl32.dll

DECLARE FUNCTION Entry ()
EXPORT
DECLARE FUNCTION DialogProc (hwndDlg, message, wParam, lParam)
DECLARE FUNCTION DisplayMyMessage (hinst, hwndOwner, msg$)
DECLARE FUNCTION lpwAlign (lpIn)

$$ID_HELP = 150
$$ID_TEXT = 200
END EXPORT

FUNCTION Entry ()

	msg$ = "Creating a dialog box in memory"
	hinst = GetModuleHandleA (0)
	DisplayMyMessage (hinst, $$HWND_DESKTOP, msg$)

END FUNCTION


FUNCTION DialogProc (hwndDlg, message, wParam, lParam)

	SELECT CASE (message)

		CASE $$WM_INITDIALOG :
			RETURN 1

		CASE $$WM_COMMAND :
			SELECT CASE (LOWORD (wParam))

				CASE $$IDOK, $$IDCANCEL :
					EndDialog (hwndDlg, LOWORD (wParam))
					RETURN 1
			END SELECT
	END SELECT

END FUNCTION

FUNCTION lpwAlign (lpIn)

	ul = lpIn
	ul = ul + 3
	ul = ul & ~(3)
	RETURN ul
END FUNCTION

FUNCTION DisplayMyMessage (hinst, hwndOwner, msg$)

	DLGTEMPLATE dt
	DLGITEMTEMPLATE dit


'	Allocate memory for dialog template
	lpdt = Xcalloc (1024)

	IFZ lpdt THEN RETURN ($$TRUE)

	' -----------------------
	' Define a dialog box.
	' -----------------------

	dt.style = $$WS_POPUP | $$WS_BORDER | $$WS_SYSMENU | $$DS_MODALFRAME | $$WS_CAPTION | $$DS_SETFONT
	dt.cdit = 3								' Number of controls
	dt.x = 50									' x position
	dt.y = 50									' y position
	dt.cx = 100								' Control width
	dt.cy = 100								' Control height

	XstCopyMemory (&dt, lpdt, SIZE (dt))		' Copy dt struct to memory
	lpw = lpdt + SIZE (dt)		' Get current position/address in memory

	USHORTAT (lpw) = 0				' No menu
	lpw = lpw + 2
	USHORTAT (lpw) = 0				' Use predefined dialog box class (by default)
	lpw = lpw + 2

	' Specify title for dialog (unicode)
	nchar = MultiByteToWideChar ($$CP_ACP, 0, &"My Dialog", - 1, lpw, 50)
	lpw = lpw + (2 * nchar)		' Get current position/address in memory

	' IF DS_SETFONT style, then specify font size
	USHORTAT(lpw) = 11
	lpw = lpw + 2

	' IF DS_SETFONT style, then specify font name (unicode)
	nchar = MultiByteToWideChar ($$CP_ACP, 0, &"Arial", - 1, lpw, 50)
	lpw = lpw + (2 * nchar)		' Get current position/address in memory

	' -----------------------
	' Define an OK button.
	' -----------------------

	lpw = lpwAlign (lpw)			' Align DLGITEMTEMPLATE on DWORD boundary

	dit.x = 10
	dit.y = 70
	dit.cx = 80
	dit.cy = 20
	dit.id = $$IDOK						' OK button identifier
	dit.style = $$WS_CHILD | $$WS_VISIBLE | $$BS_DEFPUSHBUTTON

	XstCopyMemory (&dit, lpw, SIZE (dit))
	lpw = lpw + SIZE (dit)

	USHORTAT (lpw) = 0xFFFF		' Identify next word as system class atom for control
	lpw = lpw + 2
	USHORTAT (lpw) = 0x0080		' Button class atom
	lpw = lpw + 2

	' Set control title or text (unicode)
	nchar = MultiByteToWideChar ($$CP_ACP, 0, &"OK", - 1, lpw, 50)
	lpw = lpw + (2 * nchar)

	USHORTAT (lpw) = 0				' Specify no creation data sent to dialg proc
	lpw = lpw + 2

	' -----------------------
	' Define a Help button.
	' -----------------------

	lpw = lpwAlign (lpw)			' Align DLGITEMTEMPLATE on DWORD boundary
	dit.x = 55
	dit.y = 10
	dit.cx = 40
	dit.cy = 20
	dit.id = $$ID_HELP				' Help button identifier
	dit.style = $$WS_CHILD | $$WS_VISIBLE | $$BS_PUSHBUTTON

	XstCopyMemory (&dit, lpw, SIZE (dit))
	lpw = lpw + SIZE (dit)

	USHORTAT (lpw) = 0xFFFF
	lpw = lpw + 2
	USHORTAT (lpw) = 0x0080		' Button class atom
	lpw = lpw + 2

	' Control title or text
	nchar = MultiByteToWideChar ($$CP_ACP, 0, &"Help", - 1, lpw, 50)
	lpw = lpw + (2 * nchar)

	' No creation data
	USHORTAT (lpw) = 0
	lpw = lpw + 2

	' ------------------------------
	' Define a static text control.
	' ------------------------------

	lpw = lpwAlign (lpw)		' Align DLGITEMTEMPLATE on DWORD boundary

	dit.x = 10
	dit.y = 10
	dit.cx = 40
	dit.cy = 40
	dit.id = $$ID_TEXT			' Text identifier
	dit.style = $$WS_CHILD | $$WS_VISIBLE | $$SS_LEFT

	XstCopyMemory (&dit, lpw, SIZE (dit))
	lpw = lpw + SIZE (dit)

	USHORTAT (lpw) = 0xFFFF
	lpw = lpw + 2
	USHORTAT (lpw) = 0x0082		' Static class atom
	lpw = lpw + 2

	' Set text
	nchar = MultiByteToWideChar ($$CP_ACP, 0, &msg$, -1, lpw, 150)
	lpw = lpw + (2 * nchar)
	USHORTAT (lpw) = 0		' No creation data

	' Create dialog
	ret = DialogBoxIndirectParamA (hInst, lpdt, hwndOwner, &DialogProc (), 0)

	'	Free memory
	Xfree (lpdt)

	RETURN ret
END FUNCTION

END PROGRAM