
VERSION	"0.0001" 

	IMPORT	"xst" 
	IMPORT  "xsx"
	IMPORT	"xio"	

TYPE VERTICE
	DOUBLE	.x
	DOUBLE	.y
	DOUBLE	.z
END TYPE

' ************ .raw format **************
TYPE FACET
	ULONG	.nVertices
	VERTICE	.v[5]
END TYPE

TYPE WIREOBJ
	ULONG	.nFacets
	FACET	.f[2047]
END TYPE

DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  LoadObject (fileName$, WIREOBJ obj)

FUNCTION  Entry ()

	WIREOBJ object
	XioClearConsole (XioGetStdOut())

	err = LoadObject ("cube.raw", @object)		' load an object from a file

	PRINT "nFacets="; object.nFacets


END FUNCTION
'
'
' ###########################
' #####  LoadObject ()  #####
' ###########################
'
FUNCTION  LoadObject (fileName$, WIREOBJ obj)

	ifile = OPEN(fileName$, $$RD)
	IF ifile < 0 THEN GOSUB Error

	fileSize = LOF(ifile)
	IF fileSize THEN
		text$ = NULL$(fileSize)
		READ [ifile], text$
	END IF
	CLOSE (ifile)

'	DIM text$[]
	XstStringToStringArray (text$, @text$[])

	upper = UBOUND(text$[])
	obj.nFacets = upper + 1

' parse line
	FOR i = 0 TO upper
		line$ = TRIM$(text$[i])
		GOSUB ParseLine
		index = 0
		nVertices = ULONG(data$[index])
		INC index
		obj.f[i].nVertices = nVertices

		FOR j = 0 TO nVertices-1
			obj.f[i].v[j].x = DOUBLE(data$[index]) : INC index
			obj.f[i].v[j].y = DOUBLE(data$[index]) : INC index
			obj.f[i].v[j].z = DOUBLE(data$[index]) : INC index
		NEXT j

	NEXT i

' ***** ParseLine *****
SUB ParseLine
	DIM data$[18]
	count = 0
	top = LEN(line$) - 1
	FOR v = 0 TO top
		c = line${v}
		IF c = 32 || c = 10 || c = 13 THEN
 			INC count
			DO NEXT
		END IF
		data$[count] = data$[count] + CHR$(c)
	NEXT v
END SUB

RETURN


' ***** Error *****
SUB Error
	error = ERROR (0)
	XstErrorNumberToName (error, @error$)
	PRINT "error #"; error; "  = "; error$
	IF (ifile > 3) THEN CLOSE (ifile)
	RETURN ($$TRUE)
END SUB


END FUNCTION
END PROGRAM
